// vortex2.java --- ϤϳطϤΥߥ졼
// (c)kou
// 2003.02.11
// <applet code="vortex2.class" width=600 height=600></applet>
// modified by mk (2003/3/19) Runge-Kutta ˡȤ褦ѹ

import java.applet.*;
import java.awt.*;
import java.awt.event.*;

final public class vortex2 extends Applet implements Runnable, ActionListener {

  private Image off;        // ե꡼
  private Graphics grf;     // ե꡼Υեå

  private Thread th = null; // å
        
  private Dimension d;      // ץåȤΥ
  private Dimension imgD;   // ե꡼Υ
        
  private double dt = 0.2;  // ʬ ()
  private int N = 5;        // θĿ
  private int MaxN = 12;
  private double scale = 20;// Ψ
  private int sleepTime=10; // åɤԤ
  private double[] Gamma;   // ζ ()
  private double[] Z;       // ΰ (kܤαΰ֤ (Z[2*k],Z[2*k+1]))
  private double [] Z2, f, k1, k2, k3, k4; // Runge-Kutta ˡη׻ѿ
        
  private String[] btString = {"Start", "End"}; // ܥ̾
  private Button[] bt; // ܥ
        
  private String[] laString1={"dt","N","scale","sleepTime"}; // ٥̾
  private String[] laString2={"k","","X","Y"};             // ٥̾

  private Label[] la1, la2, la3; // ٥
  private TextField[] tf1;       // ٥Фƥȥե

  private TextField[] tfGamma;   // ͤΥƥȥե
  private TextField[] tfX;       // ν֤xɸΥƥȥե
  private TextField[] tfY;       // ν֤yɸΥƥȥե
  
  private Color[] color1;        // 礤 (̤ѡ)
  private Color[] color2;        // 礤椯餤ο

  public void init() {
    int i; // 
                
    setBackground(Color.white);//طʿ
                
    d=getSize();//ץåȤΥμ
    imgD=new Dimension(d.width-200,d.height);//ե꡼ο
                
    // κ
    color1 = new Color[MaxN];
    color2 = new Color[MaxN];
    for (i = 0; i < MaxN;i++) {
      float a = i / (float)MaxN;
      color1[i]=Color.getHSBColor(a, 0.2f, 1.0f);
      color2[i]=Color.getHSBColor(a, 0.5f, 1.0f);
    }
     // ե꡼ν
    off = createImage(imgD.width,imgD.height); // ե꡼κ
    grf = off.getGraphics();                   // եåμ
    // ե꡼Υꥢ
    grf.setColor(Color.black);                 // طʿ
    grf.fillRect(0,0,imgD.width,imgD.height);  // ɤĤ֤
    // ե꡼˺ɸ
    grf.setColor(Color.gray);                  // ο
    grf.drawLine(0,imgD.height/2,imgD.width,imgD.height/2); // x
    grf.drawLine(imgD.width/2,0,imgD.width/2,imgD.height);  // y

    // 쥤ȥޥ͡Ȥʤ (ʬꤹ))
    setLayout(null);

    // Start, End ܥν
    bt= new Button[btString.length]; // ܥ
    for (i = 0; i < bt.length; i++) {
      bt[i] = new Button(btString[i]); // ܥ
      bt[i].addActionListener(this);   // ꥹʡ˴Ϣդ
      bt[i].setBounds(imgD.width,20*i,d.width-imgD.width,20);//ܥΰַ
      add(bt[i]);                      //ܥϿ
    }

    // dt, N, scale, sleepTime Υ٥롢ƥȡեɤν
    la1 = new Label[laString1.length];     // ٥
    tf1 = new TextField[laString1.length]; // ƥȥեɤ
    for (i = 0; i < la1.length; i++) {
      la1[i] = new Label(laString1[i]);    // ٥
      la1[i].setBounds(imgD.width,
                       20*(i+bt.length),
                       (d.width-imgD.width)/2,
                       20);                // ٥ΰַ
      add(la1[i]);                         // ٥Ͽ
                        
      tf1[i]=new TextField();              // ƥȥեɤ
      tf1[i].setBounds(imgD.width+(d.width-imgD.width)/2,
                       20*(i+bt.length),
                       (d.width-imgD.width)/2,
                       20);                // ƥȥեɤΰַ
      add(tf1[i]);                         // ƥȥեɤϿ
    }

    // k, , X, Y Ȥ٥ν
    la2 = new Label[laString2.length];     // ٥
    for (i = 0; i < laString2.length; i++) {
      la2[i] = new Label(laString2[i]);    // ٥
      la2[i].setBounds(imgD.width+(d.width-imgD.width)*i/4,
                       20*(bt.length+la1.length),
                       (d.width-imgD.width)/4,
                       20);                // ٥ΰַ
      add(la2[i]);                         // ٥Ͽ
    }

    // ƱΥǡ () Υ٥롢ƥȥե
    la3 = new Label[MaxN]; // ٥
    tfGamma = new TextField[MaxN];         // ƥȥեɤ
    tfX = new TextField[MaxN];             // ƥȥեɤ
    tfY = new TextField[MaxN];             // ƥȥեɤ
    for (i = 0; i < la3.length; i++) {
      la3[i] = new Label("" + (i + 1));    // ٥
      la3[i].setBounds(imgD.width+(d.width-imgD.width)*0/4,
                       20*(bt.length+la1.length+1+i),
                       (d.width-imgD.width)/4,
                       20);                // ٥ΰַ
      la3[i].setBackground(color2[i]);     // طʤ
      add(la3[i]);                         // ٥Ͽ

      tfGamma[i] = new TextField(); // ƥȥեɤ
      tfGamma[i].setBounds(imgD.width+(d.width-imgD.width)*1/4,
                           20*(bt.length+la1.length+1+i),
                           (d.width-imgD.width)/4,
                           20); // ٥ΰַ
      add(tfGamma[i]); // ƥȥեɤϿ

      tfX[i]=new TextField(); // ƥȥեɤ
      tfX[i].setBounds(imgD.width+(d.width-imgD.width)*2/4,
                       20*(bt.length+la1.length+1+i),
                       (d.width-imgD.width)/4,
                       20); // ٥ΰַ
      add(tfX[i]); // ƥȥեɤϿ

      tfY[i]=new TextField(); // ƥȥեɤ
      tfY[i].setBounds(imgD.width+(d.width-imgD.width)*3/4,
                       20*(bt.length+la1.length+1+i),
                       (d.width-imgD.width)/4,
                       20); // ٥ΰַ
      add(tfY[i]); // ƥȥեɤϿ
    }

    // ׻Ѥݤ
    Gamma = new double[MaxN];
    Z  = new double[2*MaxN];
    Z2 = new double[2*MaxN];
    f  = new double[2*MaxN];
    k1 = new double[2*MaxN];
    k2 = new double[2*MaxN];
    k3 = new double[2*MaxN];
    k4 = new double[2*MaxN];

    // ζ, ֤η
    for (i = 0; i < MaxN; i++) {
      Gamma[i]=1;
      Z[2*i]   = Math.pow(-1.0,i)*i;
      Z[2*i+1] = 0;
    }
    // ζ, ֤ƥȥեɤɽ
    tf1[0].setText("" + dt);
    tf1[1].setText("" + N);
    tf1[2].setText("" + scale);
    tf1[3].setText("" + sleepTime);
    for (i = 0; i < tfGamma.length; i++) {
      tfGamma[i].setText("" + Gamma[i]);
      tfX[i].setText("" + Z[2*i]);
      tfY[i].setText("" + Z[2*i+1]);
    }

    // ȥܥ̵
    bt[0].setEnabled(false);
  }
  
  public void paint(Graphics g) {
    update(g);
  }
  public void update(Graphics g) {
    g.drawImage(off, 0, 0, this); // ե꡼ɽ
  }
  // åɤƥ
  public void start() {
    if (th == null) {
      th = new Thread(this);
      th.start();
    }
  }
  // åɤߤ
  public void stop() {
    if (th != null) {
      th=null;
    }
  }
  // ɸѴ (xɸ)
  private int scx(double x) {
    return (int)(scale * x) + imgD.width / 2;
  }
  // ɸѴ (yɸ)
  private int scy(double y) {
    return - (int)(scale * y) + imgD.height / 2;
  }
  // 桼κɸϤʬ
  private void MydrawLine(double x1, double y1, double x2, double y2) {
    grf.drawLine(scx(x1), scy(y1), scx(x2), scy(y2));
  }
  // ϤΥ٥ȥ f(z) η׻
  public void aux(double []z, double []f, int N) {
    double doublePI = 2.0 * Math.PI;
    double sumx, sumy;
    for (int i = 0; i< N; i++) {
      sumx= 0; sumy= 0;
      for (int j = 0; j < N; j++)
        if (j != i) {
          double seki = Gamma[j] / (sqr(z[2*i]-z[2*j])+sqr(z[2*i+1]-z[2*j+1]));
          sumx -= seki * (z[2*i+1]-z[2*j+1]);
          sumy += seki * (z[2*i]-z[2*j]);
        }
        f[2*i+1] = sumy / doublePI;
        f[2*i]   = sumx / doublePI;
    }
  }
  // ׻å
  public void run() {
    int i;
    int n = 2 * N; // ϳطϤμ
    // ꥸʥǤϤ򤷤ƤǤ٤
    // double [] Z2 = new double[n];
    // double [] f  = new double[n];
    // double [] k1 = new double[n];
    // double [] k2 = new double[n];
    // double [] k3 = new double[n];
    // double [] k4 = new double[n];

    while (th != null) {
      // ԡɤԤ 100  1 ꡼פ褦ˤ
      for (int count = 0; count < 100; count++) {
        // Runge-Kutta: next Z = Z + (k1 + 2 k2 + 2 k3 + k4) / 6
        // k1
        aux(Z, f, N);
        for (i = 0; i < n; i++)
          k1[i] = dt * f[i];
        // k2
        for (i = 0; i < n; i++)
          Z2[i] = Z[i] + 0.5 * k1[i];
        aux(Z2, f, N);
        for (i = 0; i < n; i++)
          k2[i] = dt * f[i];
        // k3
        for (i = 0; i < n; i++)
          Z2[i] = Z[i] + 0.5 * k2[i];
        aux(Z2, f, N);
        for (i = 0; i < n; i++)
          k3[i] = dt * f[i];
        // k4
        for (i = 0; i < n; i++)
          Z2[i] = Z[i] + k3[i];
        aux(Z2, f, N);
        for (i = 0; i < n; i++)
          k4[i] = dt * f[i];
        // Υƥåפ (Runge-Kutta)
        for (i = 0; i < n; i++)
          Z2[i] = Z[i] + (k1[i] + 2 * (k2[i] + k3[i]) + k4[i]) / 6;
        // פ
        for (int k = 0; k < N; k++) {
          grf.setColor(color2[k]);
          MydrawLine(Z[2*k], Z[2*k+1], Z2[2*k], Z2[2*k+1]);
        }
        // ͤι
        for (i = 0; i < n; i++)
          Z[i] = Z2[i];
        // ե꡼褹
        repaint(); 
      }
      // åɤν (巯ο)
      if (sleepTime > 0) {
        try {
          th.sleep(sleepTime); //åɤ
        }
        catch(InterruptedException e) {};
      }
      th.yield(); //åɤ
    }
  }
  // ٥Ȥν
  public void actionPerformed(ActionEvent e) {
    if (e.getSource() == bt[0]) {
      // Startܥ󤬲줿
      //ȥܥ̵, ɥܥͭƥեܤ
      bt[0].setEnabled(false);
      bt[1].setEnabled(true);
      bt[1].requestFocus();

      // ƥȥեɤͤѿ
      dt = Double.valueOf(tf1[0].getText()).doubleValue();
      N = Integer.parseInt(tf1[1].getText());
      scale = Double.valueOf(tf1[2].getText()).doubleValue();
      sleepTime = Integer.parseInt(tf1[3].getText());
      for (int i = 0; i < MaxN; i++) {
        Gamma[i] = Double.valueOf(tfGamma[i].getText()).doubleValue();
        Z[2*i]   = Double.valueOf(tfX[i].getText()).doubleValue();
        Z[2*i+1] = Double.valueOf(tfY[i].getText()).doubleValue();
      }
      // N ϰϤå
      if (N > MaxN) {
        // N ͤĶƤ MaxN ˤ
        N = MaxN;
        tf1[1].setText("" + N); //ͤƥȥեɤɽ
      }
      if (N < 1) {
        // N ͤĶƤ MaxN ˤ
        N = 1;
        tf1[1].setText("" + N); //ͤƥȥեɤɽ
      }
      // ե꡼Υꥢ
      grf.setColor(Color.black);                // طʿ
      grf.fillRect(0,0,imgD.width,imgD.height); // ɤĤ֤ (ꥢ)
      grf.setColor(Color.gray);                 // ο
      grf.drawLine(0,imgD.height/2,imgD.width,imgD.height/2); // x
      grf.drawLine(imgD.width/2,0,imgD.width/2,imgD.height);  // y
      // åɤγ
      start();
    }
    else if (e.getSource() == bt[1]) {
      // Endܥ󤬲줿
      bt[0].setEnabled(true);  // ȥܥͭ
      bt[0].requestFocus();    // ȥܥ˥եܤ
      bt[1].setEnabled(false); // ɥܥ̵
      // åɤȤ
      stop();
    }
  }
  // ֤
  private double sqr(double a) {
    return a * a;
  }
}
